from django.urls import path

from . import views
from . import feeds


app_name = 'slow_forum'


urlpatterns = [
    # Views
    path('', views.IndexView.as_view(), name='index'),
    path(
        'topic/add/',
        views.TopicCreateView.as_view(),
        name='topic-add',
    ),
    path(
        'topic/add/in_category/<int:topic_category_pk>/',
        views.TopicCreateView.as_view(),
        name='topic-add-in-category',
    ),
    path(
        'topic/<int:pk>/',
        views.TopicDetailView.as_view(),
        name='topic-detail',
    ),
    path(
        'topic/<int:pk>/edit/',
        views.TopicUpdateView.as_view(),
        name='topic-update',
    ),
    path(
        'topic/<int:pk>/delete/',
        views.TopicDeleteView.as_view(),
        name='topic-delete',
    ),
    path(
        'topic/<int:topic_pk>/add_reply/',
        views.TopicReplyCreateView.as_view(),
        name='topic-reply-add',
    ),
    path(
        'topic/<int:topic_pk>/reply/<int:pk>/edit/',
        views.TopicReplyUpdateView.as_view(),
        name='topic-reply-update',
    ),
    path(
        'categories/',
        views.TopicCategoryListView.as_view(),
        name='topic-category-list',
    ),
    path(
        'categories/add/',
        views.TopicCategoryCreateView.as_view(),
        name='topic-category-add',
    ),
    path(
        'categories/<int:pk>/',
        views.TopicCategoryDetailView.as_view(),
        name='topic-category-details',
    ),
    path(
        'categories/<int:pk>/edit/',
        views.TopicCategoryUpdateView.as_view(),
        name='topic-category-update',
    ),
    path(
        'categories/<int:pk>/delete/',
        views.TopicCategoryDeleteView.as_view(),
        name='topic-category-delete',
    ),
    path(
        'topic/<int:topic_pk>/reply/<int:pk>/delete/',
        views.TopicReplyDeleteView.as_view(),
        name='topic-reply-delete',
    ),
    path(
        'user_profiles/',
        views.UserProfileListView.as_view(),
        name='user-profile-list',
    ),
    path(
        'user_profiles/<int:pk>/',
        views.UserProfileDetailView.as_view(),
        name='user-profile-detail',
    ),
    path(
        'user_profiles/<int:pk>/topics/tab/<str:tab_name>/',
        views.UserProfileDetailView.as_view(),
        name='user-profile-detail-tab',
    ),
    path(
        'user_profiles/<int:pk>/edit/',
        views.UserProfileUpdateView.as_view(),
        name='user-profile-edit-profile',
    ),
    path(
        'about/',
        views.AboutView.as_view(),
        name='about',
    ),
    # Feeds
    path(
        'feeds/',
        views.FeedsView.as_view(),
        name='feeds',
    ),
    path(
        'feeds/topics/all/',
        feeds.TopicsAllFeed(),
        name='feed-topics-all',
    ),
    path(
        'feeds/topic_replies/all/',
        feeds.TopicRepliesAllFeed(),
        name='feed-topic-replies-all',
    ),
    path(
        'feeds/topics/category/<int:category_pk>/',
        feeds.TopicsCategoryFeed(),
        name='feed-topics-category',
    ),
    path(
        'feeds/topics_replies/category/<int:category_pk>/',
        feeds.TopicRepliesCategoryFeed(),
        name='feed-topic-replies-category',
    ),
    path(
        'feeds/topics_replies/topic/<int:topic_pk>/',
        feeds.TopicRepliesTopicFeed(),
        name='feed-topic-replies-topic',
    ),
    path(
        'search/',
        views.SearchView.as_view(),
        name='search',
    ),
    path(
        'search/topics/',
        views.SearchView.as_view(search_type='topic'),
        name='search-topics',
    ),
]
